Unit DE05R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE04R_p, UTDE20_p;

procedure DE05R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real; var Y :Array of Real;
                var R :Array of Real; var IERR :Integer);

implementation

procedure DE05R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; P :Real; var H :Real; var Y :Array of Real;
                var R :Array of Real; var IERR :Integer);
var
I,I1,I10,I11,I12,I2,I3,I4,I5,I6,I7,I8,I9,JSTART :Integer;
H1,HS,X :Real;
BUL :Boolean;
label
_10,_20,_30,_40,_50;
begin
I := M*M;
I1 := 2 + M;
I2 := I1 + I;
I3 := I2 + I;
I4 := I3 + I;
I5 := I4 + I;
I6 := I5 + I;
I7 := I6 + M;
I8 := I7 + M;
I9 := I8 + M;
I10 := I9 + M;
I11 := I10 + M;
I12 := I11 + M;
for I:=1 to M do
 begin
  Y[I-1] := YN[I-1];
_10:
 end;
X := XN;
if ( XK =  X ) 
 then goto _50;
H := Sign(H,XK-X);
BUL := False;
JSTART := 1;
_20:
if ( not  BUL ) 
 then goto _30;
H := HS;
goto _50;
_30:
H1 := XK - X;
if ( Abs(H1) >  Abs(H) ) 
 then goto _40;
HS := H;
H := H1;
BUL := True;
_40:
DE04R(FA,FI,M,JSTART,HMIN,EPS,P,Y,X,H,BUL,R[0],R[1],
     R[I1-1],R[I2-1],R[I3-1],R[I4-1],R[I5-1],R[I6-1],R[I7-1],R[I8-1],
     R[I9-1],R[I10-1],R[I11-1],R[I12-1],IERR);
if ( IERR =  0 ) 
 then goto _20;
UTDE20(IERR,5);
_50:
end;

end.
